def elimina_valore(d, val):
    """Prende in ingresso un dizionario e un valore val. 
Elimina dal dizionario tutte le coppie chiave valore con valore uguale a val."""
#    if type(d) != dict:
#        print("Errore, la funzione richiede un dizionario")
#        return None
    for (k,v) in list(d.items()):
        if v == val:
            del(d[k])

def elimina_valore_safe(d, val):
    """Prende in ingresso un dizionario e un valore. 
Restituisce un dizionario con tutte le coppie chiave, valore del dizionario in ingresso 
il cui valore sia diverso dal valore in ingresso."""
    d1 = {}
    for (k,v) in d.items():
        if v != val:
            d1[k] = v
    return d1


# def combina_dizionari_primo(d1, d2):
#     """Prende in ingresso due dizionari. Restituisce un nuovo dizionario che contiene tutte le coppie del primo dizionario 
# e tutte le coppie del secondo dizionario con chiave diversa da quelle del primo."""
#     d = {}
#     # aggiungo gli elementi di d1
#     for (k,v) in d1.items():
#         d[k] = v
#     # aggiungo gli elementi di d2 non gia' presenti in d
#     for (k,v) in d2.items():
#         if not k in d:
#             d[k] = v
#     return d

# def combina_dizionari_somma(d1, d2):
#     """Prende in ingresso due dizionari. Restituisce un nuovo dizionario che contiene tutte le coppie del primo e del secondo dizionario, 
# con come valore la somma dei valori se la chiave sta in entrambi."""
#     d = {}
#     # aggiungo gli elementi di d1
#     for (k,v) in d1.items():
#         d[k] = v
#     # aggiungo gli elementi di d2 non gia' presenti in d
#     for (k,v) in d2.items():
#         if not k in d:
#             d[k] = v
#         else:
#             d[k] += v
#     return d

def combina_dizionari(d1, d2, mode):
    """Prende in ingresso due dizionari e una modalita' di combinazione. Restituisce un nuovo dizionario come combinazione dei due. 
Le chiavi che stanno solo in uno dei due, vengono inserite con il loro rispettivo valore. Per le chiavi che stanno in entrambi, 
se mode e' primo si usa il valore del primo dizionario, se e' secondo si usa il valore del secondo, se e' somma si fa la somma dei valori."""
    d = {}
    # aggiungo gli elementi di d1
    for (k,v) in d1.items():
        d[k] = v
    # aggiungo gli elementi di d2 
    for (k,v) in d2.items():
        if not k in d:
            d[k] = v
        elif mode == "primo":
            continue
        elif mode == "secondo":
            d[k] = v
        elif mode == "somma":
            d[k] += v
    return d
